package com.example.gallery.repository

import com.example.gallery.models.Album
import com.example.gallery.remote.RetrofitClient
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.withContext

class GalleryRepository {
    private val apiService = RetrofitClient.apiService

    suspend fun getAlbums(): Result<List<Album>> = withContext(Dispatchers.IO) {
        try {
            val response = apiService.getAlbums()
            Result.success(response)
        } catch (e: Exception) {
            Result.failure(e)
        }
    }

    suspend fun getAlbumDetails(albumId: Int): Result<Album> = withContext(Dispatchers.IO) {
        try {
            val response = apiService.getAlbumDetails(albumId)
            Result.success(response)
        } catch (e: Exception) {
            Result.failure(e)
        }
    }
}